#ifndef BOHA_CHAR
#define BOHA_CHAR

#include "util.h"
#include "surface.h"
#include "screen.h"

#include <memory>

class Player;
class Enemy;
class Shot;

class Charactor {
protected:
#ifndef ZAURUS
	typedef double Num_;
	typedef Point Point_;
#else
	typedef Num Num_;
	typedef NPoint Point_;
#endif

public:
    // _ufBXpb`
    virtual void hit (Charactor*) = 0;
    virtual void hitByPlayer (Player*) {};
    virtual void hitByEnemy (Enemy*) {};
    virtual void hitByShot (Shot*) {};

    bool isHit(const Charactor* bc) const {
		int diffx = std::abs(center_.xi() - bc->center().xi());
		if (diffx > 20) return false;
		int diffy = std::abs(center_.yi() - bc->center().yi());
		if (diffy > 20) return false;
		return true;
	}

    virtual void wallEvent();

    Charactor (const Point_& pnt, Surface* graph);
    virtual ~Charactor();

    const Point_& pnt() const { return pnt_; }
    const Point_& spd() const { return spd_; }
    virtual const Point_& size() const { return graph_->size(); }
    const bool alive() const { return alive_; }

    const Point_& center() const {
		return center_;
    }

    void moveValue();
    void moveGraphic () const;

protected:
	void calcCenter() {
#ifndef ZAURUS
		center_ = pnt_ + Point(graph_->size().xi()>>1, graph_->size().yi()>>1);
#else
		center_ = pnt_ + NPoint(
			Num(graph_->size().xi()>>1),
			Num(graph_->size().yi()>>1));
#endif
	}

    Charactor();

	Point_ pnt_, spd_, center_;

	Surface* graph_;
    bool alive_;

    Surface* surface_;

    // ʂôH
    bool zako_;

	int turn_;
};

#endif // BOHA_CHAR

