#ifndef BOHA_COMMAND
#define BOHA_COMMAND

#include <bulletml/bulletmlrunner.h>

#ifndef ZAURUS
typedef double BMLNum;
#else
#include "util/util.h"
typedef Num BMLNum;
#endif

class Enemy;

class EnemyCommand : public BulletMLRunner {
public:
	EnemyCommand(BulletMLParser* state, Enemy* enemy);
	EnemyCommand(BulletMLParser* state, BulletMLNode* node, Enemy* enemy);
	EnemyCommand(BulletMLState* state, Enemy* enemy);

protected:
	virtual BMLNum getBulletDirection();
	virtual BMLNum getAimDirection();
	virtual BMLNum getBulletSpeed();
	virtual BMLNum getDefaultSpeed();
	virtual BMLNum getRank();
	virtual void createSimpleBullet(BMLNum direction, BMLNum speed);
	virtual void createBullet(BulletMLState* state,
							  BMLNum direction, BMLNum speed);
	virtual int getTurn();
	virtual void doVanish();
	virtual void doChangeDirection(BMLNum direction);
	virtual void doChangeSpeed(BMLNum speed);
	virtual void doAccelX(BMLNum speedx);
	virtual void doAccelY(BMLNum speedy);
	virtual BMLNum getBulletSpeedX();
	virtual BMLNum getBulletSpeedY();

	virtual BMLNum getRand();

private:
	Enemy* enemy_;

};

#endif // ! BOHA_COMMAND

