#include "player.h"
#include "enemy.h"
#include "conf.h"
#include "game.h"
#include "shot.h"
#include "replay.h"

Player::Player (const Point_& pnt, Surface* graph, MSDL::InputBase& inputMgr)
    : Charactor(pnt, graph), inputMgr_(inputMgr) {
	zako_ = false;
}

void Player::hitByPlayer (Player*) {
	assert(0);
}

void Player::hitByEnemy (Enemy* bc) {
    if (center().nlength(bc->center()) < Conf::instance()->playerSize())
		if (!Conf::instance()->watch())
			Game::instance()->end();
}

void Player::hitByShot (Shot* bc) {
    if (center().nlength(bc->center()) < Conf::instance()->playerSize())
		if (!Conf::instance()->watch())
			Game::instance()->end();
}

void Player::keyEvent() {
#ifndef ZAURUS
#define GET_DOUBLE(arg) arg
	typedef double Num_;
#else
#define GET_DOUBLE(arg) arg##.getDouble()
	typedef Num Num_;
#endif

	spd_ = Point_(Num_(0), Num_(0));

	SDL_PumpEvents();

	Num_ base;

	bool button;
	MSDL::Axis axis;
#ifndef ZAURUS
	if (Conf::instance()->isReplay()) {
		int code = Game::instance()->getReplay()->popInput();
		button = code & 16;
		axis = MSDL::Axis(code & 15);
	}
	else {
#endif
		button = inputMgr_.getButton(0);
		axis = inputMgr_.getAxis();
#ifndef ZAURUS
	}
#endif

	static const Num_ N_SQRT_TWO_INV(1.0/SQRT_TWO);
	if (button) base = Num_(Conf::instance()->playerSpeed2());
	else base = Num_(Conf::instance()->playerSpeed());
	Num_ cross = Num_(base * N_SQRT_TWO_INV);

	if (axis == MSDL::Axis::UP) spd_.y = -base;
	else if (axis == MSDL::Axis::RIGHT) spd_.x = base;
	else if (axis == MSDL::Axis::DOWN) spd_.y = base;
	else if (axis == MSDL::Axis::LEFT) spd_.x = -base;
	else if (axis == MSDL::Axis::UPRIGHT) {
		spd_.x = cross;
		spd_.y = -cross;
	}
	else if (axis == MSDL::Axis::DOWNRIGHT) {
		spd_.x = cross;
		spd_.y = cross;
	}
	else if (axis == MSDL::Axis::DOWNLEFT) {
		spd_.x = -cross;
		spd_.y = cross;
	}
	else if (axis == MSDL::Axis::UPLEFT) {
		spd_.x = -cross;
		spd_.y = -cross;
	}

	char v = axis.getAxisCode();
	if (button) v |= 16;
#ifndef ZAURUS
	Game::instance()->getReplay()->pushInput(v);
#endif
}

Player::~Player() {}

