/**
 * $Id$
 *
 * Copyright (C) shinichiro.h <g940455@mail.ecc.u-tokyo.ac.jp>
 *  http://user.ecc.u-tokyo.ac.jp/~g940455/wp/
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef angle_h_
#define angle_h_

#include "util.h"
#include "numconfig.h"

#include <cmath>

#ifndef ZAURUS
typedef double Num_;
inline Num_ sine(Num_ v) {
	return std::sin(v);
}
inline Num_ cosine(Num_ v) {
	return std::cos(v);
}
#else
const int DIV = 4096;
const Num_ PI_N = Num_(PI);

extern Num_ sintbl[DIV];
extern Num_ costbl[DIV];
extern int atantbl[DIV+1];
extern Num_ sqrttbl[DIV];

void initTable();
inline Num_ sine(Num_ v) {
	return sintbl[v.val & 4095];
}
inline Num_ cosine(Num_ v) {
	return costbl[v.val & 4095];
}

Num_ square(Num_ v);
Num_ getAngle(Num_ nx, Num_ ny);
#endif

Num_ dtor(Num_ x);
Num_ rtod(Num_ x);

#endif // ! angle_h_

